<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: Object Descriptor APIs</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Object Descriptor APIs<br/>
<small>
[<a class="el" href="group__group__vx__framework__object.html">Framework Objects</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__obj__desc__cmd__t.html">tivx_obj_desc_cmd_t</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Command object descriptor.  <a href="structtivx__obj__desc__cmd__t.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">union &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="uniontivx__obj__desc__shm__entry__t.html">tivx_obj_desc_shm_entry_t</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Object Descriptor Shared memory entry which can hold any of the supported object descriptor types.  <a href="uniontivx__obj__desc__shm__entry__t.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__obj__desc__table__info__t.html">tivx_obj_desc_table_info_t</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Data structure to hold info about object descriptor table.  <a href="structtivx__obj__desc__table__info__t.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga473e11e04aa7dd29797f3cb1bf9b1ba3">tivxObjDescAlloc</a> (<a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a> type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Allocate a Object descriptor.  <a href="#ga473e11e04aa7dd29797f3cb1bf9b1ba3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga422c0dd5f70c5cf5bf21e8a22344b5e0">tivxObjDescFree</a> (<a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> **obj_desc)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Free a previously allocated object descriptor.  <a href="#ga422c0dd5f70c5cf5bf21e8a22344b5e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#gacbe637a2134841596d5565877d33d8b3">tivxObjDescSend</a> (uint32_t dst_target_id, uint16_t obj_desc_id)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sends a object descriptor to specified target.  <a href="#gacbe637a2134841596d5565877d33d8b3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga43ebdbb9272f3336019357538f5c6e8c">tivxObjDescGet</a> (uint16_t obj_desc_id)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get obj descriptor corresponding to the object descriptor ID.  <a href="#ga43ebdbb9272f3336019357538f5c6e8c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga7a5db8d3c1c9582edec01558e6d38152">tivxObjDescIsValidType</a> (<a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *obj_desc, <a class="el" href="group__group__tivx__obj__desc.html#ga4858f5eeb4edfc862b9b8b2039ed8109">tivx_obj_desc_type_e</a> type)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Checks if object desc pointer is valid and it is of required type.  <a href="#ga7a5db8d3c1c9582edec01558e6d38152"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga8311436304a2969b378a58395a114b2c">tivxObjDescInit</a> (void)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Init object descriptor module.  <a href="#ga8311436304a2969b378a58395a114b2c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">uint16_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#gae19ec92d7558538be397f29b891091fa">tivxReferenceGetObjDescId</a> (<a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a> ref)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Function to get the descriptor object from the given reference.  <a href="#gae19ec92d7558538be397f29b891091fa"></a><br/></td></tr>
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga0e5252d445f658c22676ab8f86c32dbe">TIVX_CMD_FLAG_SEND_ACK</a>&nbsp;&nbsp;&nbsp;(0x00000001u)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Flag to indicate if command receiver needs to ACK this command.  <a href="#ga0e5252d445f658c22676ab8f86c32dbe"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga778ff616ae76e7139f1d5b3b83312754">TIVX_CMD_FLAG_IS_ACK</a>&nbsp;&nbsp;&nbsp;(0x00000002u)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Flag to indicate if this is a command or ACK for a command.  <a href="#ga778ff616ae76e7139f1d5b3b83312754"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#ga986852f6569bebf0af3bbba4c7456dfc">TIVX_OBJ_DESC_ID_SHIFT</a>&nbsp;&nbsp;&nbsp;(8u)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shift for storing Object Descriptor id in 32bit variable.  <a href="#ga986852f6569bebf0af3bbba4c7456dfc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__obj__desc__priv.html#gaa6e5cb564ae207e34e389ded7fbf1de2">TIVX_OBJ_DESC_ID_MASK</a>&nbsp;&nbsp;&nbsp;(0x0000FFFFu)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Mask for storing Object Descriptor id in 32bit variable.  <a href="#gaa6e5cb564ae207e34e389ded7fbf1de2"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="ga0e5252d445f658c22676ab8f86c32dbe"></a><!-- doxytag: member="tivx_obj_desc_priv.h::TIVX_CMD_FLAG_SEND_ACK" ref="ga0e5252d445f658c22676ab8f86c32dbe" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TIVX_CMD_FLAG_SEND_ACK&nbsp;&nbsp;&nbsp;(0x00000001u)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag to indicate if command receiver needs to ACK this command. </p>

</div>
</div>
<a class="anchor" id="ga778ff616ae76e7139f1d5b3b83312754"></a><!-- doxytag: member="tivx_obj_desc_priv.h::TIVX_CMD_FLAG_IS_ACK" ref="ga778ff616ae76e7139f1d5b3b83312754" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TIVX_CMD_FLAG_IS_ACK&nbsp;&nbsp;&nbsp;(0x00000002u)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag to indicate if this is a command or ACK for a command. </p>

</div>
</div>
<a class="anchor" id="ga986852f6569bebf0af3bbba4c7456dfc"></a><!-- doxytag: member="tivx_obj_desc_priv.h::TIVX_OBJ_DESC_ID_SHIFT" ref="ga986852f6569bebf0af3bbba4c7456dfc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TIVX_OBJ_DESC_ID_SHIFT&nbsp;&nbsp;&nbsp;(8u)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Shift for storing Object Descriptor id in 32bit variable. </p>

</div>
</div>
<a class="anchor" id="gaa6e5cb564ae207e34e389ded7fbf1de2"></a><!-- doxytag: member="tivx_obj_desc_priv.h::TIVX_OBJ_DESC_ID_MASK" ref="gaa6e5cb564ae207e34e389ded7fbf1de2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TIVX_OBJ_DESC_ID_MASK&nbsp;&nbsp;&nbsp;(0x0000FFFFu)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Mask for storing Object Descriptor id in 32bit variable. </p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga473e11e04aa7dd29797f3cb1bf9b1ba3"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxObjDescAlloc" ref="ga473e11e04aa7dd29797f3cb1bf9b1ba3" args="(vx_enum type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a>* tivxObjDescAlloc </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85">vx_enum</a>&nbsp;</td>
          <td class="paramname"> <em>type</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a Object descriptor. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>type</em>&nbsp;</td><td>[in] Type of object descriptor to allcoate, see <a class="el" href="group__group__tivx__obj__desc.html#ga4858f5eeb4edfc862b9b8b2039ed8109">tivx_obj_desc_type_e</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Pointer <a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> on success </dd>
<dd>
NULL, if object descriptor could not be allocated </dd></dl>

</div>
</div>
<a class="anchor" id="ga422c0dd5f70c5cf5bf21e8a22344b5e0"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxObjDescFree" ref="ga422c0dd5f70c5cf5bf21e8a22344b5e0" args="(tivx_obj_desc_t **obj_desc)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxObjDescFree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> **&nbsp;</td>
          <td class="paramname"> <em>obj_desc</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free a previously allocated object descriptor. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>obj_desc</em>&nbsp;</td><td>Object descriptor to free </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gacbe637a2134841596d5565877d33d8b3"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxObjDescSend" ref="gacbe637a2134841596d5565877d33d8b3" args="(uint32_t dst_target_id, uint16_t obj_desc_id)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxObjDescSend </td>
          <td>(</td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>dst_target_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&nbsp;</td>
          <td class="paramname"> <em>obj_desc_id</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sends a object descriptor to specified target. </p>
<p>The API does not wait for ACK. ACK handling if any is done by user The API may result in a IPC is target is on another CPU</p>
<p>Source target ID is not required since ACK is not handled by this API</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>dst_target_id</em>&nbsp;</td><td>Destination target ID </td></tr>
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>obj_desc_id</em>&nbsp;</td><td>Object descriptor ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga43ebdbb9272f3336019357538f5c6e8c"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxObjDescGet" ref="ga43ebdbb9272f3336019357538f5c6e8c" args="(uint16_t obj_desc_id)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a>* tivxObjDescGet </td>
          <td>(</td>
          <td class="paramtype">uint16_t&nbsp;</td>
          <td class="paramname"> <em>obj_desc_id</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get obj descriptor corresponding to the object descriptor ID. </p>
<p>If obj_desc_id is invalid or out of bounds NULL is returned.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"><tt>[in]</tt>&nbsp;</td><td valign="top"><em>obj_desc_id</em>&nbsp;</td><td>Object descriptor ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga7a5db8d3c1c9582edec01558e6d38152"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxObjDescIsValidType" ref="ga7a5db8d3c1c9582edec01558e6d38152" args="(tivx_obj_desc_t *obj_desc, tivx_obj_desc_type_e type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a> tivxObjDescIsValidType </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__obj__desc__t.html">tivx_obj_desc_t</a> *&nbsp;</td>
          <td class="paramname"> <em>obj_desc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__group__tivx__obj__desc.html#ga4858f5eeb4edfc862b9b8b2039ed8109">tivx_obj_desc_type_e</a>&nbsp;</td>
          <td class="paramname"> <em>type</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Checks if object desc pointer is valid and it is of required type. </p>

</div>
</div>
<a class="anchor" id="ga8311436304a2969b378a58395a114b2c"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxObjDescInit" ref="ga8311436304a2969b378a58395a114b2c" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void tivxObjDescInit </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Init object descriptor module. </p>

</div>
</div>
<a class="anchor" id="gae19ec92d7558538be397f29b891091fa"></a><!-- doxytag: member="tivx_obj_desc_priv.h::tivxReferenceGetObjDescId" ref="gae19ec92d7558538be397f29b891091fa" args="(vx_reference ref)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t tivxReferenceGetObjDescId </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a1a95c3bf180e49d4d1ecd64cb35f45a3">vx_reference</a>&nbsp;</td>
          <td class="paramname"> <em>ref</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Function to get the descriptor object from the given reference. </p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
